#include <Arduino.h>
#include <U8x8lib.h>
#include <SPI.h>
#include <Wire.h>

#define button 3
U8X8_SSD1306_128X32_UNIVISION_HW_I2C u8x8(/* reset=*/ U8X8_PIN_NONE);   // Adafruit ESP8266/32u4/ARM Boards + FeatherWing OLED
unsigned long rpmtime;
float rpmfloat;
unsigned int rpm;
unsigned int lastrpm = 0;
bool tooslow = 1;
bool refresh = 1;
int fps = 750;
unsigned long last = 0;
bool cisto = 0;

void setup() {
  Serial.begin(9600);
  u8x8.begin();
  u8x8.setFont(u8x8_font_profont29_2x3_f);
  TCCR1A = 0;
  TCCR1B = 0;
  TCCR1B |= (1 << CS12); //Prescaler 256
  TIMSK1 |= (1 << TOIE1); //enable timer overflow
  pinMode(2, INPUT);
  attachInterrupt(0, RPM, FALLING);
  pinMode(button, INPUT);
}

ISR(TIMER1_OVF_vect) {
  tooslow = 1;
}

void loop() {
  if(digitalRead(button) == 0){
    cisto = 0;
    u8x8.setFont(u8x8_font_profont29_2x3_f);
    if(millis() - last >= fps){
      refresh = 1;
    }
    
    if(refresh == 1){
      if (tooslow == 1) {
        u8x8.clear();
        u8x8.drawString(1, 0, "Slow");
      }
      else {
        rpmfloat = 120 / (rpmtime/ 31250.00);
        rpm = round(rpmfloat);
        u8x8.clear();
        u8x8.setCursor(1,0);
        u8x8.print(rpm);
        lastrpm = rpm;
      }
      last = millis();
      refresh = 0;
    }
  }
  else{
    if (cisto == 0){
      u8x8.clear();
      cisto = 1;
      delay(50);
    }
    u8x8.setFont(u8x8_font_px437wyse700b_2x2_r);
    u8x8.drawString(1, 0, "Press");
    u8x8.setCursor(1,2);
    u8x8.print(lastrpm);
  }
}

void RPM () {
  rpmtime = TCNT1;
  TCNT1 = 0;
  tooslow = 0;
}
